<?PHP
/*
  SdAuth: sd_auth.php
  The simplest Login authentification script for Cake PHP.
  If you need only One Username & One Password, this is useful.
  (C) 2006 Shunro Dozono / dozono @No_SPAM@ gmail.com

1) put sd_auth.php(this file) to app/controllers/components.
   put login.thtml            to app/views/layouts.

2) Copy app_controller.php 
    from cake/appcontroller.php to app/

3) Add following lines.

class AppController extends Controller {

	var $components = array('SdAuth');

	function beforeFilter()
	{
		// Auth Check.
		if($this->SdAuth->isloggedin() == FALSE){
    		$this->layout = '';
            $this->render('../layouts/login');
            exit();
		} else {
			$this->layout = "default";
		};
	}

}

4) in a ****s_controller.php, add a logout method,

	function logout(){
		$this->SdAuth->logout();
		$this->redirect("/index.php");
	}

*/

define("USER_NAME","admin");     // change to your own username.
define("PASSWORD","pass");       // change to your own password.
define("SESSION_KEY","AxkEzRY"); // change to your own key.

class SdAuthComponent extends Object
{
	var $components = array('RequestHandler', 'Session');

	/**
	 * islogin
	 * 
	 * @param void
	 * @return ture/false
	 */
	function isloggedin(){
		
		$islogin = $this->Session->read(SESSION_KEY);
		if($islogin == TRUE){
			return True;
		} else {
		//not yet logged in.
			// check
			if(isset($_POST['mode']) && $_POST['mode'] =='auth_login'){
				//data was posted.
				return $this->check($_POST['username'],$_POST['password']);
			} else {
				//You can't enter!
				return false;
			}
		}
	}

	/**
	 * check
	 * 
	 * @param $username
	 * @param $password
	 * @return true/false
	 */
	function check($username, $password){
		
		if($username == USER_NAME && $password == PASSWORD){
			$this->Session->write(SESSION_KEY,true);
			return true;
		} else {
			$this->Session->write(SESSION_KEY,false);
			return false;
		}
		
	}
	/**
	 * logout
	 * 
	 * @param void
	 * @return void
	 */
	function logout(){
		$this->Session->write(SESSION_KEY,false);
	}
}

?>